require 'omniauth/strategies/oauth2'

module OmniAuth
  module Strategies
    class Classiclaw < OmniAuth::Strategies::OAuth2
      # Give your strategy a name.
      option :name, "classiclaw"

      # This is where you pass the options you would pass when
      # initializing your consumer from the OAuth gem.
      option :client_options, {:site => "http://122.112.18.6:33000"}

      # These are called after authentication has succeeded. If
      # possible, you should try to set the UID without making
      # additional calls (if the user id is returned with the token
      # or as a URI parameter). This may not be possible with all
      # providers.
      uid{ raw_info['uid'] }

      info do
        {
          :name => raw_info['name'],
          :email => raw_info['email'],
          :court_id => raw_info['court_id'],
          :courtroom_id => raw_info['courtroom_id'],
          :dlbs => raw_info['dlbs'],
          :rybs => raw_info['rybs']
        }
      end

      extra do
        {
          'raw_info' => raw_info
        }
      end

      def raw_info
        @raw_info ||= access_token.get('/api/v1/profile.json').parsed
        token_params = access_token.params
        @raw_info.merge({
          'uid' => token_params['uid'],
          'name' => token_params['realname'],
          'court_id' => token_params['court_id'],
          'courtroom_id' => token_params['courtroom_id'],
          'dlbs' => token_params['dlbs'],
          'rybs' => token_params['rybs']
        })
      end
    end
  end
end
